#SingleInstance Force
;#WinActivateForce
#UseHook

#Include %A_ScriptDir%/src/IniDefine.ahk
#Include %A_ScriptDir%/src/HotkeyDefine.ahk
#Include %A_ScriptDir%/src/CommandLine.ahk

autoexecute:
	WinKill ,ahk_class %ClipWin%
	while (title == "ERROR") || (title == "") || (titleSetMode == "true")
		GoSub,whileProcess
	
	Run, %A_ScriptDir%/src/ClipCursor.exe
	WinWait, ahk_class %ClipWin%
	WinSetTitle, ahk_class %ClipWin%, ,ClipCursor.exe
	GoSub,WinMoveProcess
	
	while (title == "ERROR") || (title == "") {
		IniRead, title, %IniFile%,%IniSection% , %IniKey%
		sleep,1000
	}
	ControlSetText, %ClipEdit% ,%title%, ahk_class %ClipWin%
	TTS(title,1000)
	SetTimer,CheckClipWin,2000
	
	GoSub,GuiSetting
	OnExit, ButtonI
return


/*
=====================================
L[{[h
=====================================
*/
StartStopToggle:
	GoSub,StartORStop
	if ButtonText = start
		GoSub,Start
	else if ButtonText = stop
		GoSub,Stop
return
Stop:
*F13::
	IfWinActive, ahk_id %PresentActiveWindowID%
	{	GoSub,StartORStop
		if ButtonText = start
			return
		GoSub,SwitchAction
		GoSub,ActiveWindowSwitching
		TTS("stop",300)
	}
	else	GoSub,ElseThisHotkey
return

Start:
*F17::
	IfWinActive , %title%
	{	GoSub,StartORStop
		if ButtonText = start
			GoSub,SwitchAction
		MouseGetPos, , , PresentActiveWindowID
		TTS("start",300)
	}
	else	GoSub,ElseThisHotkey
return

#Include %A_ScriptDir%/src/ElseThisHotkey.ahk

showTitleSetWindow:
	GuiControlGet, visible, Focus
	if (visible != "")
			Gui,cancel
	else {
		GuiControl,, edit, %title%
		Gui,Show
		oldTitle = %title%
	}
return

/*
=====================================
GUI֘A
=====================================
*/
GuiSetting:
	ShortCutKeyText = Toggle : %ToggleKey%         Show : %ShowKey%        Start : %StartKey%        Stop : %StopKey%
	Gui, Add, Text , x20 y10, %ShortCutKeyText%
	Gui, Add, Edit , x10 yP+30 W300 vedit, %title%
	Gui, Add, Button,xp+320 yP-1 , }EXw
	Gui, Add, Button,x100 yP+51 w60, OK
	Gui, Add, Button,x200 yP+0  w60, LZ
	Gui, Add, Button,x300 yP+0  w60, I
return
Button}EXw:
	GoSub, WaitSelectWindow
	WinGetTitle, title, A
	GoSub,MouseFollowOff
	GuiControl, Text, edit ,%title%
return
ButtonOK:
	GUI, Submit, NoHide
	if(edit != "")
	{	IniWrite, %title%,%IniFile%,%IniSection%, %IniKey%
		TTS(title " œo^")
	}
	GUI, Submit
return
ButtonLZ:
	GoSub,GuiClose
return
ButtonI:
	WinKill ,ahk_class %ClipWin%
ExitApp

GuiClose:
	GuiControlGet, editVal, ,edit
	if(oldTitle != editVal)
	{	msgbox,4,,TitleύXĂ܂BۑɏIĂ낵łH
		IfMsgbox,No
			GoSub,ButtonOK
	}
	Gui,Cancel
return



/*
=====================================
x
=====================================
*/
;F13ƂɁAEBhE؂ւȂƃ}EX̐ȂClipCursor.exe̎dlB
ActiveWindowSwitching:
	Send,!{Tab}
	WinActivate, ahk_id %PresentActiveWindowID%
return
StartORStop:
	ControlGetText, ButtonText ,%ClipButton%,ahk_class %ClipWin%
return
SwitchAction:
	ControlSend , %ClipButton% ,%A_Space%,ahk_class %ClipWin%
return


/*
=====================================
SetTimerp
=====================================
*/
MouseFollow:
	MouseGetPos,mX,mY, id
	WinGetTitle, title, ahk_id %id%
	ToolTip,%title%,mX+20,mY+30
return
CheckClipWin:
	IfWinNotExist,ahk_class %ClipWin%
		ExitApp
	IfWinNotActive, ahk_id %PresentActiveWindowID%
	{	ControlGetText, ButtonText ,%ClipButton%,ahk_class %ClipWin%
		if ButtonText = start
			return
		GoSub,SwitchAction
	}
return



WaitSelectWindow:
		SetTimer,MouseFollow,100
		KeyWait,LButton,D T30
		if ErrorLevel = 1
		{	msgbox,4,,s𒆎~܂H
			IfMsgbox,Yes
				ExitApp
			reload		;continueƕsB
		}
return

MouseFollowOff:
		SetTimer,MouseFollow,Off
		ToolTip
		sleep,500
return



whileProcess:
		msgbox,4,,TargetWindowTitle擾ł܂B`n`nLɂEBhENbNĂB
		IfMsgbox,No
			GoSub,ButtonI
		GoSub,WaitSelectWindow

		WinGetTitle, title, A
		GoSub,MouseFollowOff
		
		TTS(title " œo^")
		sleep,1500
		
		IniWrite, %title%,%IniFile%,%IniSection%, %IniKey%
		titleSetMode := "false"
		sleep,1000
return


WinMoveProcess:
	if (debugMode != "true")
		WinMove,ahk_class %ClipWin%,,%x%,0
	else
		WinMove,ahk_class %ClipWin%,,10,10
return
